# coding: utf-8

"""
    RIME Rest API

    API methods for RIME. Must be authenticated with `rime-api-key` header.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FirewallProjectIdBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'firewall_id': 'str',
        'name': 'str',
        'bin_size': 'RimeBinSize',
        'run_ct_schedule': 'bool',
        'data_location_info': 'RimeDataLocation',
        'stress_test_run_id': 'str',
        'managed_image': 'RimeManagedImageReference',
        'reference_set_source': 'RimeReferenceSetSource'
    }

    attribute_map = {
        'firewall_id': 'firewallId',
        'name': 'name',
        'bin_size': 'binSize',
        'run_ct_schedule': 'runCtSchedule',
        'data_location_info': 'dataLocationInfo',
        'stress_test_run_id': 'stressTestRunId',
        'managed_image': 'managedImage',
        'reference_set_source': 'referenceSetSource'
    }

    def __init__(self, firewall_id=None, name=None, bin_size=None, run_ct_schedule=None, data_location_info=None, stress_test_run_id=None, managed_image=None, reference_set_source=None):  # noqa: E501
        """FirewallProjectIdBody - a model defined in Swagger"""  # noqa: E501
        self._firewall_id = None
        self._name = None
        self._bin_size = None
        self._run_ct_schedule = None
        self._data_location_info = None
        self._stress_test_run_id = None
        self._managed_image = None
        self._reference_set_source = None
        self.discriminator = None
        if firewall_id is not None:
            self.firewall_id = firewall_id
        if name is not None:
            self.name = name
        if bin_size is not None:
            self.bin_size = bin_size
        if run_ct_schedule is not None:
            self.run_ct_schedule = run_ct_schedule
        if data_location_info is not None:
            self.data_location_info = data_location_info
        if stress_test_run_id is not None:
            self.stress_test_run_id = stress_test_run_id
        if managed_image is not None:
            self.managed_image = managed_image
        if reference_set_source is not None:
            self.reference_set_source = reference_set_source

    @property
    def firewall_id(self):
        """Gets the firewall_id of this FirewallProjectIdBody.  # noqa: E501

        Optional. Used to permit pre-generating the ID in the web UI.  # noqa: E501

        :return: The firewall_id of this FirewallProjectIdBody.  # noqa: E501
        :rtype: str
        """
        return self._firewall_id

    @firewall_id.setter
    def firewall_id(self, firewall_id):
        """Sets the firewall_id of this FirewallProjectIdBody.

        Optional. Used to permit pre-generating the ID in the web UI.  # noqa: E501

        :param firewall_id: The firewall_id of this FirewallProjectIdBody.  # noqa: E501
        :type: str
        """

        self._firewall_id = firewall_id

    @property
    def name(self):
        """Gets the name of this FirewallProjectIdBody.  # noqa: E501


        :return: The name of this FirewallProjectIdBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FirewallProjectIdBody.


        :param name: The name of this FirewallProjectIdBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def bin_size(self):
        """Gets the bin_size of this FirewallProjectIdBody.  # noqa: E501


        :return: The bin_size of this FirewallProjectIdBody.  # noqa: E501
        :rtype: RimeBinSize
        """
        return self._bin_size

    @bin_size.setter
    def bin_size(self, bin_size):
        """Sets the bin_size of this FirewallProjectIdBody.


        :param bin_size: The bin_size of this FirewallProjectIdBody.  # noqa: E501
        :type: RimeBinSize
        """

        self._bin_size = bin_size

    @property
    def run_ct_schedule(self):
        """Gets the run_ct_schedule of this FirewallProjectIdBody.  # noqa: E501

        If false, don't run CTSchedule. Schedule frequency and other info determined by bin size.  # noqa: E501

        :return: The run_ct_schedule of this FirewallProjectIdBody.  # noqa: E501
        :rtype: bool
        """
        return self._run_ct_schedule

    @run_ct_schedule.setter
    def run_ct_schedule(self, run_ct_schedule):
        """Sets the run_ct_schedule of this FirewallProjectIdBody.

        If false, don't run CTSchedule. Schedule frequency and other info determined by bin size.  # noqa: E501

        :param run_ct_schedule: The run_ct_schedule of this FirewallProjectIdBody.  # noqa: E501
        :type: bool
        """

        self._run_ct_schedule = run_ct_schedule

    @property
    def data_location_info(self):
        """Gets the data_location_info of this FirewallProjectIdBody.  # noqa: E501


        :return: The data_location_info of this FirewallProjectIdBody.  # noqa: E501
        :rtype: RimeDataLocation
        """
        return self._data_location_info

    @data_location_info.setter
    def data_location_info(self, data_location_info):
        """Sets the data_location_info of this FirewallProjectIdBody.


        :param data_location_info: The data_location_info of this FirewallProjectIdBody.  # noqa: E501
        :type: RimeDataLocation
        """

        self._data_location_info = data_location_info

    @property
    def stress_test_run_id(self):
        """Gets the stress_test_run_id of this FirewallProjectIdBody.  # noqa: E501

        The `stress_test_run_id` defines the completed stress test run from which the firewall's configuration parameters are inferred.  # noqa: E501

        :return: The stress_test_run_id of this FirewallProjectIdBody.  # noqa: E501
        :rtype: str
        """
        return self._stress_test_run_id

    @stress_test_run_id.setter
    def stress_test_run_id(self, stress_test_run_id):
        """Sets the stress_test_run_id of this FirewallProjectIdBody.

        The `stress_test_run_id` defines the completed stress test run from which the firewall's configuration parameters are inferred.  # noqa: E501

        :param stress_test_run_id: The stress_test_run_id of this FirewallProjectIdBody.  # noqa: E501
        :type: str
        """

        self._stress_test_run_id = stress_test_run_id

    @property
    def managed_image(self):
        """Gets the managed_image of this FirewallProjectIdBody.  # noqa: E501


        :return: The managed_image of this FirewallProjectIdBody.  # noqa: E501
        :rtype: RimeManagedImageReference
        """
        return self._managed_image

    @managed_image.setter
    def managed_image(self, managed_image):
        """Sets the managed_image of this FirewallProjectIdBody.


        :param managed_image: The managed_image of this FirewallProjectIdBody.  # noqa: E501
        :type: RimeManagedImageReference
        """

        self._managed_image = managed_image

    @property
    def reference_set_source(self):
        """Gets the reference_set_source of this FirewallProjectIdBody.  # noqa: E501


        :return: The reference_set_source of this FirewallProjectIdBody.  # noqa: E501
        :rtype: RimeReferenceSetSource
        """
        return self._reference_set_source

    @reference_set_source.setter
    def reference_set_source(self, reference_set_source):
        """Sets the reference_set_source of this FirewallProjectIdBody.


        :param reference_set_source: The reference_set_source of this FirewallProjectIdBody.  # noqa: E501
        :type: RimeReferenceSetSource
        """

        self._reference_set_source = reference_set_source

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FirewallProjectIdBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FirewallProjectIdBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
